#input name for a message file and two output share files
#output two files with DC-net inputs

import sys
import os
import math

MSG_SIZE = 100
DB_ROWS = 2048

#check for right number of params
if len(sys.argv) != 4:
    print("wrong number of params!")
    sys.exit()

msgFileName = str(sys.argv[1])
s1FileName = str(sys.argv[2])
s2FileName = str(sys.argv[3])

msgFile = open(msgFileName, "r")
msg = bytes(msgFile.read(), 'ascii')
msgFile.close()

#pad message to appropriate length
msgLen = len(msg)
if msgLen > MSG_SIZE:
    print("msg too long!")
    sys.exit()
paddedMsg = msg + bytes(MSG_SIZE - msgLen)


#produce random shares for input to DC-net

dbSize = MSG_SIZE * DB_ROWS

#first share is just random
s1Share = os.urandom(dbSize)

s2Share = bytearray(dbSize)

#TODO: write the code to produce the second share 
#NOTE: to check your work, use merge.py on the outputs of this program
#It should give you back your message after a random number between 0 and DB_ROWS

#write the shares to the given files
s1File = open(s1FileName, "w")
s2File = open(s2FileName, "w")
s1File.write(s1Share.hex())
s2File.write(s2Share.hex())
s1File.close()
s2File.close()
