#input two filenames with shares to be merged
#output the resulting messages with empty entries skipped

import sys
import os

MSG_SIZE = 100
DB_ROWS = 2048

def isAllZeros(row):
    for b in row:
        if b:
            return False
    return True

#check for right number of params
if len(sys.argv) != 3:
    print("wrong number of params!")
    sys.exit()

s1FileName = str(sys.argv[1])
s2FileName = str(sys.argv[2])

s1File = open(s1FileName, "r")
s2File = open(s2FileName, "r")

s1Output = bytes.fromhex(s1File.read())
s2Output = bytes.fromhex(s2File.read())

s1File.close()
s2File.close()

dbSize = MSG_SIZE*DB_ROWS
mergedDB = bytearray(dbSize)

#produce the merged output
i = 0
while i < dbSize:
    mergedDB[i] = s1Output[i] ^ s2Output[i]
    i+=1

#filter out the empty rows to get the real output
output = bytearray()
j = 0
while j < DB_ROWS:
    if not isAllZeros(mergedDB[j*MSG_SIZE:(j+1)*MSG_SIZE]):
        print(str(j)+": "+mergedDB[j*MSG_SIZE:(j+1)*MSG_SIZE].decode())
    j+=1


