#input a folder name holding shares and an output file name
#output a file with all the provided shares merged

import sys
import os

MSG_SIZE = 100
DB_ROWS = 2048

#check for right number of params
if len(sys.argv) != 3:
    print("wrong number of params!")
    sys.exit()

inFolderName = str(sys.argv[1])
outFileName = str(sys.argv[2])

dbSize = MSG_SIZE*DB_ROWS

outputShare = bytearray(dbSize)

#XOR together all the user inputs
myDir = os.getcwd()
inDir = myDir + "/" + inFolderName
for fileName in os.listdir(inDir):
    inFile = open(inDir + "/" + fileName, "r")
    uInput = bytes.fromhex(inFile.read())
    inFile.close()
    i = 0
    while i < dbSize:
        outputShare[i] = outputShare[i] ^ uInput[i]
        i+=1

#write the merged share of DB to output file
outFile = open(outFileName, "w")
outFile.write(outputShare.hex())
outFile.close()
