#takes private key file and names for input and output folders
#decrypts each file in input folder, shuffles them, and writes them to the output folder

import os
import sys
import random
import nacl.utils
from nacl.encoding import HexEncoder
from nacl.public import PrivateKey, SealedBox

if len(sys.argv) < 4:
    print("need name for key file and input/output folders")
    sys.exit()


keyFileName = str(sys.argv[1])
inFolderName = str(sys.argv[2])
outFolderName = str(sys.argv[3])

#if this is the last server, output the results
finalOutput = False
if outFolderName == "output":
    finalOutput = True

#get the secret key
keyFile = open(keyFileName, "r")
key = bytes.fromhex(keyFile.read())
sk = PrivateKey(key, HexEncoder)
decryptor = SealedBox(sk)

myDir = os.getcwd()
inDir = myDir + "/" + inFolderName
outDir = myDir + "/" + outFolderName
outputs = []

#for each file in the input directory, read it, decrypt, and put in outputs
for fileName in os.listdir(inDir):
    inFile = open(inDir + "/" + fileName, "r")
    ct = bytes.fromhex(inFile.read())
    out = decryptor.decrypt(ct)
    outputs.append(out)
    inFile.close()

#shuffle outputs
#NOTE: this shuffle does not use cryptographic randomness
#included here only for demonstration purposes
random.shuffle(outputs)

count = 0
for out in outputs:
    if finalOutput == True: #print to terminal
        print(str(count)+": "+out.decode())
    else: #write outputs to files
        outFileName = outDir + "/" + str(count) + ".txt"
        outFile = open(outFileName, "w")
        outFile.write(out.hex())
        outFile.close()
    count += 1
